<?php
    $src = file_get_contents('regexor.sql');
  
    // we need to replace all escaped quotes or the regex below will go nuts
    $src = str_replace(['\\"', "\\'"], ['[Q1]', '[Q1]'], $src);
    
    $regexes = [
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Init DB[ \t]+travian\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SET NAMES \'UTF8\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT Count\(\*\) as Total FROM s1_users WHERE timestamp > \d{0,100} AND tribe!=\d{1,2} AND tribe!=\d{1,2} AND tribe!=\d{1,2}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users WHERE access<( )?8 AND id > \d{1,1000} AND tribe<=3 AND tribe > 0 ORDER BY (oldrank|ap|dp|clp|RR) (ASC|DESC)(, id DESC)? Limit 1(0)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (SQL_CACHE )?(tribe|plus|gold|alliance|b4|id(,username)?|maxevasion|username|\*|access|cp|vac_mode,vac_time) FROM (`)?s1_users(`)?( where ((`)?id(`)?( )?=( )?(\')?\d{0,100}(\')?|(`)?username(`)? (=|LIKE) \'[^\']+\'( and username != \'[^\']+\')?|tribe = \d{0,100}|alliance = \d{0,100}|timestamp > \d{0,100}( and username != \'[^\']+\')?|access = \d{0,100})( ORDER BY (ap|dp|clp|RR) DESC(, id DESC)? Limit 1)?)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT email FROM s1_users WHERE email = \'[^\']+\' LIMIT 1\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Quit[ \t]+\n?/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT username FROM s1_users where username = \'[^\']+\' LIMIT 1\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id,( )?password,( )?(sessid,)?( )?is_bcrypt FROM s1_users where username = \'[^\']+\'( and access >= 8)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (act|vac_mode|quest) FROM s1_users where username = \'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id, village_select FROM `s1_users` WHERE `username`=\'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (SQL_CACHE )?(\*|wref|name|owner) FROM (`)?s1_vdata(`)?( WHERE (`)?(wref|owner)(`)? [=><] (\')?\d{0,100}(\')?( AND (`)?(capital|wref)(`)? (!)?= \d{0,100})?)?( LIMIT 1)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT wref from s1_vdata where owner = \d{0,100} order by capital DESC,pop DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT sit(2)? FROM s1_online where uid = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT SUM\(hero\) from s1_enforcement where `from` = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (SUM\(hero\)|\*) from s1_units where (`)?vref(`)?( )?=( )?(\')?\d{0,100}(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT SUM\(t\d{0,100}\) from s1_prisoners where `from` = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.from = \'\d{0,100}\' and s1_movement.ref = s1_attacks.id and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.to = \'\d{0,100}\' and s1_movement.ref = s1_attacks.id and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|dead) FROM s1_hero WHERE (`)?uid(`)?( )?=( )?\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT inrevive FROM s1_hero WHERE `uid` = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT intraining FROM s1_hero WHERE `uid` = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+REPLACE into s1_active values \(\'[^\']+\',\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Connect[ \t]+[^@]+@[a-zA-Z]+ as anonymous on \n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata WHERE target IN\([^)]+\) and send = 0 and archived = 0 ORDER BY time DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata WHERE owner IN\([^)]+\) ORDER BY time DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata WHERE target IN\([^)]+\) and send = 0 and archived = 0 and deltarget = 0 ORDER BY time DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata WHERE owner IN\([^)]+\) and delowner = 0 ORDER BY time DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata where target IN\([^)]+\) and send = 0 and archived = 1\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata where target IN\([^)]+\) and send = 0 and archived = 1 and deltarget = 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|uid) FROM s1_ndata( where (`)?(u)?id(`)? = (\')?\d{0,100}(\')?( and del = 0)?)?( ORDER BY time DESC)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|evasion|name|maxcrop) FROM s1_vdata where wref = (\'?)\d{0,100}(\')?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|f\d{0,100}t|wwname) from s1_fdata where vref = \d{0,100}( LIMIT 1)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (x,y|id, fieldtype|id,( )?oasistype(,occupied)?|oasistype,occupied|\*) FROM (`)?s1_wdata(`)? where (`)?id(`)? = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_units where vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_enforcement where (\`)?vref(\`)?( )?=( )?\d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_enforcement where `from` = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT e.\*,o.conqured FROM s1_enforcement as e LEFT JOIN s1_odata as o ON e.vref=o.wref where o.conqured = \d{0,100} AND e.from !=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT e.\*,o.conqured FROM s1_enforcement as e LEFT JOIN s1_odata as o ON e.vref=o.wref where o.conqured = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT o.\*, w.x, w.y FROM s1_odata AS o LEFT JOIN s1_wdata AS w ON o.wref=w.id WHERE conqured = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_prisoners where (s1_prisoners.)?(`)?from(`)? = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement where s1_movement.from = \'\d{0,100}\' and sort_type = 5 and proc = 0 ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_tdata where vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_abdata where vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_research where vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_bdata where wid = \d{0,100}( and (field|type|loopcon) = \d{0,100})?( and master = \d{0,100})?( order by master,timestamp ASC)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_artefacts WHERE vref = (\')?\d{0,100}(\')? AND type = (\')?\d{0,100}(\')?( order by size)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM (`)?s1_artefacts(`)?( WHERE (owner|id|size) = \d{0,100}( AND type = \d{0,100}( AND size=\d{0,100})?)?)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_artefacts WHERE owner = \d{0,100} AND active = 1 AND type = \d{0,100} AND size=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_artefacts WHERE vref = \d{0,100}( AND active = 1 AND type = \d{0,100} AND size=\d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_artefacts WHERE vref = \d{0,100} AND \(\(type = \d{0,100} AND kind = \d{0,100}\) OR \(owner = \d{0,100} AND size > 1 AND active = 1 AND type = \d{0,100} AND kind = \d{0,100}\)\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT wood,clay,iron,crop,maxstore,maxcrop from s1_(v|o)data where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_bdata where wid = \d{0,100} order by master,timestamp ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (count\(id\)|\*) FROM s1_users where id > \d{0,100}( AND tribe<=\d{0,100} AND tribe > \d{0,100} ORDER BY oldrank ASC Limit \d{0,100})?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT s1_users.id userid,( s1_users.tribe tribe,)? s1_users.username username(, s1_users.oldrank oldrank)?,( )?s1_users.alliance alliance, \(\n\n[^A-Za-z]+SELECT SUM\( s1_vdata.pop \)\n[^A-Za-z]+FROM s1_vdata\n[^A-Za-z]+WHERE s1_vdata.owner = userid\n[^A-Za-z]+\)totalpop, \(\n[^A-Za-z]+SELECT COUNT\( s1_vdata.wref \)\n[^A-Za-z]+FROM s1_vdata\n[^A-Za-z]+WHERE s1_vdata.owner = userid AND type != 99\n[^A-Za-z]+\)totalvillages, \(\n[^A-Za-z]+SELECT s1_alidata.tag\n[^A-Za-z]+FROM s1_alidata, s1_users\n[^A-Za-z]+WHERE s1_alidata.id = s1_users.alliance\n[^A-Za-z]+AND s1_users.id = userid\n[^A-Za-z]+\)allitag\n[^A-Za-z]+FROM s1_users\n[^A-Za-z]+WHERE( s1_users.access < \d{0,100}\n[^A-Za-z]+ AND)? s1_users.tribe (<=|=) \d{0,100}( AND s1_users.access < \d{0,100})?\n[^A-Za-z]+AND s1_users.id > \d{0,100}\n[^A-Za-z]+ORDER BY totalpop DESC, totalvillages DESC, userid DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_medal order by week DESC LIMIT 0, 1\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users where oldrank = 0 and id > 5\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_odata WHERE wood < \d{0,100} OR clay < \d{0,100} OR iron < \d{0,100} OR crop < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_vdata WHERE maxstore < \d{0,100} OR maxcrop < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_vdata WHERE wood > maxstore OR clay > maxstore OR iron > maxstore OR crop > maxcrop\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_vdata WHERE wood < 0 OR clay < 0 OR iron < 0 OR crop < 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_odata WHERE maxstore < \d{0,100} OR maxcrop < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM `s1_ww_attacks` WHERE `attack_time` <= \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT sum\(cp\) FROM s1_vdata where owner = \d{0,100} and natar = 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_hero( WHERE (`)?uid(`)? = \d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_hero WHERE (`)?dead(`)?( )?=( )?(\')?\d{0,100}(\')?( AND (uid|`heroid`)=\d{0,100}( LIMIT 1)?)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (uid|timestamp) FROM s1_deleting where (timestamp < \d{0,100}|uid = \d{0,100})\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_bdata where timestamp < \d{0,100} and master = 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (f\d{0,100}|vref) from s1_fdata where (f\d{0,100}(t)? = \'[^\']+\' AND )?vref = \d{0,100}( LIMIT 1)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (owner|maxstore) FROM s1_vdata where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users WHERE access < 8\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id,name,tag,oldrank,Aap,Adp FROM s1_alidata where id != \'\' ORDER BY id DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users where alliance = \d{0,100} order  by \(SELECT sum\(pop\) FROM s1_vdata WHERE owner =  s1_users.id\) desc, s1_users.id desc\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT sum\(pop\) FROM s1_vdata where owner = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (type|count\(\*\)|\*|conqured|name) FROM (`)?s1_odata(`)? WHERE (`)?(conqured|wref)(`)?( )?=( )?(\')?\d{0,100}(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT starv FROM s1_vdata where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|tag|count\(id\)|name, tag) from s1_alidata where id (!)?= (\')?\d{0,100}(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_bdata WHERE master = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (wood|clay|iron|crop) FROM s1_vdata where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_bdata where wid = \d{0,100} and type = \d{0,100} and master = 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_bdata where wid = \d{0,100} and field [<>] \d{0,100} and master = 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_demolition WHERE (timetofinish<=\d{0,100}|vref=\d{0,100})\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM `s1_fdata`\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_route where timestamp < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_send where s1_movement.ref = s1_send.id and s1_movement.proc = 0 and sort_type = 0 and endtime < \d{0,100}(\.\d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement where proc = 0 and sort_type = 2 and endtime < \d{0,100}(\.\d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_research where timestamp < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_training where vref IS NOT NULL\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_vdata where starv != 0 and owner != \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT e.\*,o.conqured,o.wref,o.high, o.owner as ownero, v.owner as ownerv FROM s1_enforcement as e LEFT JOIN s1_odata as o ON e.vref=o.wref LEFT JOIN s1_vdata as v ON e.from=v.wref where o.conqured=\d{0,100} AND o.owner(<>|=)v.owner\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT e.\*, v.owner as ownerv, v1.owner as owner1 FROM s1_enforcement as e LEFT JOIN s1_vdata as v ON e.from=v.wref LEFT JOIN s1_vdata as v1 ON e.vref=v1.wref where e.vref=\d{0,100} AND v.owner(<>|=)v1.owner\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_vdata where celebration < \d{0,100} AND celebration != 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.ref = s1_attacks.id and s1_movement.proc = \'0\' and s1_movement.sort_type = \'\d{0,100}\' and s1_attacks.attack_type != \'\d{0,100}\' and endtime < \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_wdata left JOIN s1_vdata ON s1_vdata.wref = s1_wdata.id where s1_wdata.id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.to = \'\d{0,100}\' and s1_movement.ref = s1_attacks.id and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} or s1_movement.to = \'\d{0,100}\' and s1_movement.ref = s1_attacks.id and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT capital,wref,name,pop,created from s1_vdata where owner = \d{0,100} order by pop desc\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|owner|clay|iron|wood|crop) FROM s1_odata where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_wdata left JOIN s1_odata ON s1_odata.wref = s1_wdata.id where s1_wdata.id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_(v|o)data WHERE loyalty<>100\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.ref = s1_attacks.id and s1_movement.proc = \'0\' and s1_movement.sort_type = \'\d{0,100}\'( and s1_attacks.attack_type = \'\d{0,100}\')? and endtime < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_send where s1_movement.ref = s1_send.id and s1_movement.proc = 0 and sort_type = \d{0,100} and endtime < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement where (ref = 0 and )?proc = (\')?0(\')? and sort_type = (\')?\d{0,100}(\')? and endtime < \d{0,100}(\.\d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_general WHERE shown = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users WHERE invited (!=|<|>) 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_banlist WHERE active = 1 and end < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_banlist WHERE uid = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|wref) FROM s1_odata where conqured = 0 and lastupdated2 < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_config\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_artefacts where type = \d{0,100} and active = 1 and lastupdate <= \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement,s1_odata, s1_attacks where s1_odata.wref = \'\d{0,100}\' and s1_movement.to = \d{0,100} and s1_movement.ref = s1_attacks.id and s1_attacks.attack_type != \d{0,100} and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement where s1_movement.to = \'\d{0,100}\' and sort_type = \d{0,100} and ref = \d{0,100} and proc = 0 ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.(from|to) = (\')?\d{0,100}(\')? (and s1_movement.(from|to) = (\')?\d{0,100}(\')?)? and s1_movement.ref = s1_attacks.id and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} and (\()?s1_attacks.attack_type = \d{0,100}( or s1_attacks.attack_type = \d{0,100}\))? ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT a.wref, a.name, b.x, b.y from s1_vdata AS a left join s1_wdata AS b ON b.id = a.wref where owner = \d{0,100} order by capital DESC,pop DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM `s1_links` WHERE `userid` = \d{0,100} ORDER BY `pos` ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_enforcement where `from` = \d{0,100} and vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (wood|clay|iron|crop) FROM s1_vdata WHERE wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT sum\(s1_send.merchant\) from s1_send, s1_movement where s1_movement.from = \'\d{0,100}\' and s1_send.id = s1_movement.ref and s1_movement.proc = 0 and sort_type = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT sum\(ref\) from s1_movement where sort_type = \d{0,100} and s1_movement.to = \'\d{0,100}\' and proc = 0\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (sum\(merchant\)|\*) from s1_market where vref = \d{0,100} and accept = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement(, s1_send)? where s1_movement.(to|from) = \'\d{0,100}\'( and s1_movement.ref = s1_send.id)? and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT vref FROM s1_fdata WHERE f99 = \'\d{0,100}\' and f99t = \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_prisoners where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT\n[^A-Za-z]+s1_wdata.id AS map_id,\n[^A-Za-z]+s1_wdata.fieldtype AS map_fieldtype,\n[^A-Za-z]+s1_wdata.oasistype AS map_oasis,\n[^A-Za-z]+s1_wdata.x AS map_x,\n[^A-Za-z]+s1_wdata.y AS map_y,\n[^A-Za-z]+s1_wdata.occupied AS map_occupied,\n[^A-Za-z]+s1_wdata.image AS map_image,\n\n[^A-Za-z]+s1_odata.conqured AS oasis_conqured,\n[^A-Za-z]+info_user_oasis.username AS oasis_user,\n[^A-Za-z]+info_user_oasis.tribe AS oasis_tribe,\n[^A-Za-z]+info_alliance_oasis.tag AS oasis_alli_name,\n\n[^A-Za-z]+s1_vdata.wref AS ville_id,\n[^A-Za-z]+s1_vdata.owner AS ville_user,\n[^A-Za-z]+s1_vdata.name AS ville_name,\n[^A-Za-z]+s1_vdata.capital AS ville_capital,\n[^A-Za-z]+s1_vdata.pop AS ville_pop,\n\n[^A-Za-z]+s1_users.id AS user_id,\n[^A-Za-z]+s1_users.username AS user_username,\n[^A-Za-z]+s1_users.tribe AS user_tribe,\n[^A-Za-z]+s1_users.alliance AS user_alliance,\n\n[^A-Za-z]+s1_alidata.id AS aliance_id,\n[^A-Za-z]+s1_alidata.tag AS aliance_name\n\n[^A-Za-z]+FROM \(\(\(\(\(\(s1_wdata\n[^A-Za-z]+LEFT JOIN s1_vdata ON s1_vdata.wref = s1_wdata.id \)\n[^A-Za-z]+LEFT JOIN s1_odata ON s1_odata.wref = s1_wdata.id \)\n[^A-Za-z]+LEFT JOIN s1_users AS info_user_oasis ON info_user_oasis.id = s1_odata.owner \)\n[^A-Za-z]+LEFT JOIN s1_alidata AS info_alliance_oasis ON info_alliance_oasis.id = info_user_oasis.alliance \)\n[^A-Za-z]+LEFT JOIN s1_users ON s1_users.id = s1_vdata.owner \)\n[^A-Za-z]+LEFT JOIN s1_alidata ON s1_alidata.id = s1_users.alliance \)\n[^A-Za-z]+where s1_wdata.id IN \([^)]+\)\n[^A-Za-z]+ORDER BY FIND_IN_SET\(s1_wdata.id,\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_diplomacy WHERE (\()?alli(1|2) = (\'[^\']*\'|\d{0,100})( (or|and) alli2 = (\')?[^\']*(\')?\))?( AND (\()?type = \'\d{0,100}\')? AND accepted = (\')?\d{0,100}(\')?(\))?( OR alli2 = \'[^\']+\' AND type = \'[^\']+\' AND accepted = \'[^\']+\')?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_diplomacy WHERE alli1 = \d{0,100} AND alli2 = \d{0,100} AND accepted = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_diplomacy WHERE alli1 = \'[^\']*\' AND type = \'\d{0,100}\' OR alli2 = \'[^\']*\' AND type = \'\d{0,100}\' AND accepted = \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (id,x,y,occupied(,fieldtype)?|\*) FROM s1_wdata WHERE fieldtype = \d{0,100}( OR fieldtype = \d{0,100})?( and \(x [><] (-)?\d{0,100} and x [<>] (-)?\d{0,100}\) and \(y [><] (-)?\d{0,100} and y [<>] (-)?\d{0,100}\) and occupied = 0)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT s1_users.id userid, s1_users.username username, s1_users.(a|d)pall,  \(\n\n[^A-Za-z]+SELECT COUNT\( s1_vdata.wref \)\n[^A-Za-z]+FROM s1_vdata\n[^A-Za-z]+WHERE s1_vdata.owner = userid AND type != \d{0,100}\n[^A-Za-z]+\)totalvillages, \(\n\n[^A-Za-z]+SELECT SUM\( s1_vdata.pop \)\n[^A-Za-z]+FROM s1_vdata\n[^A-Za-z]+WHERE s1_vdata.owner = userid\n[^A-Za-z]+\)pop\n[^A-Za-z]+FROM s1_users\n[^A-Za-z]+WHERE s1_users.(a|d)pall >=0 AND s1_users.access < 8 AND s1_users.tribe <= 3\n[^A-Za-z]+AND s1_users.id > 5\n[^A-Za-z]+ORDER BY s1_users.(a|d)pall DESC, pop DESC, userid DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT v.wref,v.name,v.owner,v.pop FROM s1_vdata AS v,s1_users AS u WHERE v.owner=u.id AND u.tribe<=3 AND v.wref != \'[^\']*\' AND u.access<8\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users WHERE tribe!=0 AND tribe!=4 AND tribe!=5\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+select s1_users.id, s1_users.username,s1_users.alliance, s1_fdata.wwname, s1_fdata.f99, s1_vdata.name, s1_fdata.vref  \n[^A-Za-z]+FROM s1_users  \n[^A-Za-z]+INNER JOIN s1_vdata ON s1_users.id = s1_vdata.owner \n[^A-Za-z]+INNER JOIN s1_fdata ON s1_fdata.vref = s1_vdata.wref \n[^A-Za-z]+WHERE s1_fdata.f99t = \d{0,100} ORDER BY s1_fdata.f99 Desc, id Desc LIMIT \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_mdata WHERE owner=\'\d{0,100}\' AND time > \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id,categorie,plaats,week,img,points from s1_(alli)?medal where (userid|allyid) = \d{0,100} and del = 0 order by id desc\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id from s1_users where sit1 = \d{0,100} or sit2 = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id FROM s1_users WHERE access = \d{0,100} AND id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT count\(\*\) as count FROM s1_users WHERE id != \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users ORDER BY id DESC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_movement, s1_attacks where s1_movement.to = \'\d{0,100}\' and s1_movement.ref = s1_attacks.id and s1_movement.proc = 0 and s1_movement.sort_type = \d{0,100} and s1_attacks.attack_type = \d{0,100} ORDER BY endtime ASC\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users where invited = \d{0,100} order by regtime desc\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \(IF\(exp1=0,1,0\)\+IF\(exp2=0,1,0\)\+IF\(exp3=0,1,0\)\) FROM s1_vdata WHERE wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \(u\d{0,100}\+u\d{0,100}\+u\d{0,100}\) FROM (s1_units|s1_enforcement) WHERE (vref|`from`) = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_training where vref = \d{0,100} ORDER BY id\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT maxstore, maxcrop, wood, clay, iron, crop FROM s1_vdata WHERE wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_ndata WHERE (ally = \d{0,100} AND )?((\()?ntype(!)?=\d{0,100}(\))?( (and|or) )?)+?( AND ally = \d{0,100})?( AND toWref = \d{0,100})?( AND uid = \d{0,100})? ORDER BY time DESC Limit \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_wdata where x = (-)?\d{0,100} AND y = (-)?\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT exp\d{0,100} FROM s1_vdata where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT u.protect FROM s1_users u,s1_vdata v WHERE u.id=v.owner AND v.wref=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_a2b where ckey = \'[^\']+\' AND time_check = \'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|opt\d{0,100}|rank) FROM s1_ali_permission where uid = \d{0,100}( && alliance = \d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|alliance|forum_name) from s1_forum_cat where (alliance|id) = (\')?[^\']+(\')?( AND forum_area = \d{0,100})?( ORDER BY id)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (count\(id\)|\*|close|id) FROM s1_forum_topic where (cat|id|owner)( )?=( )?(\')?[^\']+(\')?( AND stick = \'[^\']*\')?( order by post_date)?( (asc|desc))?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (result|\*) from s1_forum_edit where alliance = \'[^\']+\'\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|count\(id\)) from s1_forum_post where (topic|owner) = \'[^\']+\'\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (\*|count\(id\)) from s1_forum_survey where (topic|owner) = (\')?[^\']+(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+select \* from s1_chat where alli=\'[^\']+\' order by id desc limit \d{0,100},\d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* from s1_ali_log where aid = \d{0,100} ORDER BY date DESC\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (tag|name|\*|id) FROM s1_alidata where (tag|name|leader)( )?=( )?(\')?[^\']*(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_ali_invite where (uid = \d{0,100}( and )?)?(alliance = \d{0,100}( && accept = \d{0,100})?)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT SQL_CACHE \* FROM s1_active\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT SUM\(gold\) AS sumofgold FROM s1_users\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT SUM\(u\d{0,100}\) AS sumof FROM s1_units\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT @@version, @@version_comment\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SET .*\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SHOW TABLES FROM .*\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT `[^`]+` FROM `INFORMATION_SCHEMA`.*\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT `comment`\n[^A-Za-z]+FROM `phpmyadmin`.`pma__column_info`\n[^A-Za-z]+WHERE db_name     = \'[^\']+\'\n[^A-Za-z]+AND table_name  = \'[^\']*\'\n[^A-Za-z]+AND column_name = \'[^\']*\'\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT s1_alidata.tag from s1_users join s1_alidata where s1_users.alliance = s1_alidata.id and s1_users.id = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_farmlist WHERE (owner = \d{0,100}|wref = \d{0,100}|id = \d{0,100})( ORDER BY wref (ASC|DESC))?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_raidlist WHERE lid = \d{0,100}( ORDER BY (distance|id) ASC)?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT (email|username) FROM s1_activate where (username|email) = \'[^\']+\' LIMIT 1\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT id, lastupdate FROM s1_users WHERE lastupdate < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_vdata WHERE capital = \'\d{0,100}\' and owner [><] \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT v.wref, v.owner, v.name, v.capital, v.pop,u.username, u.tribe, u.access, w.x, w.y FROM s1_vdata AS v LEFT JOIN s1_users AS u ON v.owner=u.id LEFT JOIN s1_wdata AS w ON v.wref=w.id( WHERE tribe<>5)?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT Count\(size\) AS totals,\n[^A-Za-z]+SUM\(IF\(size = \'\d{0,100}\',\d{0,100},\d{0,100}\)\) small,\n[^A-Za-z]+SUM\(IF\(size = \'\d{0,100}\',\d{0,100},\d{0,100}\)\) great,\n[^A-Za-z]+SUM\(IF\(size = \'\d{0,100}\',\d{0,100},\d{0,100}\)\) `unique`\n[^A-Za-z]+FROM s1_artefacts WHERE owner = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_users WHERE access < \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+SELECT \* FROM s1_route where (u)?id = \d{0,100}( ORDER BY timestamp ASC)?\n/i',

        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users SET vac_mode = \'\d{0,100}\' , vac_time=\'\d{0,100}\' WHERE id=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set (sessid|ok|plus|gold|b1|b2|alliance|act|invited|access) = (\()?(\')?(\d{0,100}|[^\']+)(\')?(\)(( )?[+-]( )?\d{0,100})?)? where (`)?(username|id)(`)?( )?=( )?(\')?([^\']+|\d{0,100})(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set timestamp = (\')?\d{0,100}(\')? where username = \'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_vdata set wood = (-)?\d{0,100}(\.\d{0,100})?, clay = (-)?\d{0,100}(\.\d{0,100})?, iron = (-)?\d{0,100}(\.\d{0,100})?, crop = (-)?\d{0,100}(\.\d{0,100})? where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_vdata set (lastupdate|cp|pop|starv|starvupdate|crop|name|maxstore|maxcrop|loyalty|exp\d{0,100}) = (\')?(\d{0,100}|[^\']+)(\')? where wref = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_odata set wood = (-)?\d{0,100}(\.\d{0,100})?, clay = (-)?\d{0,100}(\.\d{0,100})?, iron = (-)?\d{0,100}(\.\d{0,100})?, crop = (-)?\d{0,100}(\.\d{0,100})? where wref = \d{0,100}(\.\d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_odata set lastupdated = \d{0,100} where wref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE `s1_odata` SET conqured=\d{0,100},loyalty=\d{0,100},lastupdated=\d{0,100},owner=\d{0,100},name=\'[^\']+\' WHERE wref=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set cp = cp \+ \d{0,100}(\.\d{0,100})?, lastupdate = \d{0,100} where id = \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE (`)?s1_hero(`)? SET (dead|health|level|`attack`|`defence`|`attackbonus`|`defencebonus`|`regeneration`|(`)?points(`)?) = ((\')?\d{0,100}(\')?|`attack`|`defence`|`attackbonus`|`defencebonus`|`regeneration`|(`)?points(`)?)( [+-] \d{0,100})? WHERE (heroid|(`)?uid(`)?) = (\')?\d{0,100}(\')?\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE `s1_hero` SET lastupdate = \'\d{0,100}\' WHERE heroid = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE `s1_hero` SET health = \'\d{0,100}(\.\d{0,100})?\' WHERE heroid = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_fdata set (f\d{0,100}(t)?( )?=( )?(\')?\d{0,100}(\')?(,)?( )?)+? where vref( )?=( )?\d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set (clp|dpall|apall|dp|ap|RR) = (clp|dpall|apall|dp|ap|RR) [+-] (-)?\d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set oldrank = \d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_bdata set loopcon = 0 where loopcon = 1 and master = 0 and wid = \d{0,100}( and field [<>] \d{0,100})?\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_bdata SET timestamp = \d{0,100} WHERE id = \'[^\']*\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_alidata set (clp|Adp|Aap|dp|ap|RR) = (clp|Adp|Aap|dp|ap|RR) [+-] (-)?\d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_alidata set oldrank = \d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE `s1_vdata` SET `maxstore` = \d{0,100}, `maxcrop` = \d{0,100} WHERE `wref` = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_units set ((u\d{0,100}(o)?|hero)( )?=( )?((u\d{0,100}(o)?|hero) [+-]  (-)?)?\d{0,100}( )?(,)?( )?)* WHERE vref = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_training set amt = amt - \d{0,100}, timestamp2 = timestamp2 \+ \d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_units set hero = hero -   WHERE vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_attacks set (t1=t1 - \d{0,100},( )?t2=t2 - \d{0,100},( )?t3=t3 - \d{0,100},( )?t4=t4 - \d{0,100},( )?t5=t5 - \d{0,100},( )?t6=t6 - \d{0,100},( )?t7=t7 - \d{0,100},( )?t8=t8 - \d{0,100},( )?t9=t9 - \d{0,100},( )?t10=t10 - \d{0,100},( )?t11=t11 - \d{0,100})*? WHERE id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_movement set proc = 1 where moveid = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+update s1_hero set (`)?(health|experience)(`)?( )?=( )?(`)?(health|experience)(`)?( )?[+-]( )?(-)?\d{0,100} where (`)?(heroid|uid)(`)?=\d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_enforcement set u\d{0,100} = u\d{0,100} [+-] \d{0,100} where id = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_enforcement set ((u-)?\d{0,100}|hero) = ((u-)?\d{0,100}|hero) [+-] \d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users SET village_select=\d{0,100} WHERE id=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_general SET shown = \d{0,100} WHERE id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_ndata set viewed = 1 where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_mdata set viewed = 1 where id = \d{0,100} AND target IN\([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set gender = \d{0,100}, location = \'[^\']+\', birthday = \'[^\']+\', desc1 = \'[^\']+\', desc2 = \'[^\']+\' where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_demolition SET timetofinish=\d{0,100} WHERE vref=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_research SET timestamp=\d{0,100} WHERE vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_abdata set (a|b)\d{0,100} = (a|b)\d{0,100} \+ \d{0,100} where vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_wdata set occupied = \d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_forum_cat set forum_name = \'[^\']+\', forum_des = \'[^\']+\' where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_forum_survey set vote\d{0,100} = vote\d{0,100} \+ \d{0,100}, voted = \'[^\']+\' where topic = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_forum_topic set post = \'[^\']+\', alliance0 = \d{0,100}, player0 = \d{0,100}, coor0 = \d{0,100}, report0 = \d{0,100} where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_forum_edit set result = \'[^\']*\' where alliance = \'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_ali_permission SET rank = \'[^\']*\', opt1 = \'[^\']*\', opt2 = \'[^\']*\', opt3 = \'[^\']*\', opt4 = \'[^\']*\', opt5 = \'[^\']*\', opt6 = \'[^\']*\', opt7 = \'[^\']*\' where uid = \d{0,100} && alliance =\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_alidata set name = \'[^\']*\', tag = \'[^\']*\' where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_alidata SET `(notice|forumdblink)` = \'[^\']*\'(, `desc` = \'[^\']*\')? where id = \d{0,100}\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set quest = \'\d{0,100}\' where username = \'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users set gender = \d{0,100}, location = \'[^\']*\', birthday = \'[^\']*\', desc1 = \'[^\']*\', desc2 = \'[^\']*\' where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_fdata SET \n[^A-Za-z]+([^A-Za-z]*f\d{0,100}(t)?( )*=( )*\'\d{0,100}\'(,)?( )*\n)* [^A-Za-z]+WHERE vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users SET \n[^A-Za-z]+access = \d{0,100},\n[^A-Za-z]+gold = \d{0,100},  \n[^A-Za-z]+sit1 = \'\d{0,100}\',\n[^A-Za-z]+sit2 = \'\d{0,100}\',\n[^A-Za-z]+protect = \'\d{0,100}\',\n[^A-Za-z]+cp = \d{0,100},\n[^A-Za-z]+ap = \'\d{0,100}\', \n[^A-Za-z]+dp = \'\d{0,100}\', \n[^A-Za-z]+RR = \'\d{0,100}\', \n[^A-Za-z]+apall = \'\d{0,100}\', \n[^A-Za-z]+dpall = \'\d{0,100}\' \n[^A-Za-z]+WHERE id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_users SET desc2 = \'[*]+\n[^A-Za-z]+\[#natars\]\n[^A-Za-z]+[*]+\' WHERE id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_artefacts SET vref = \d{0,100}, owner = \d{0,100}, conquered = \d{0,100}, active = \d{0,100} WHERE vref = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_artefacts SET kind = \d{0,100}, bad_effect = \d{0,100}, effect2 = \d{0,100}, lastupdate = \d{0,100} WHERE id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+UPDATE s1_route set (timeleft|wood|clay|iron|crop|start|deliveries|merchant|timestamp) = (((timeleft|wood|clay|iron|crop|start|deliveries|merchant|timestamp) \+ \d{0,100})|\d{0,100})? where id = \d{0,100}\n/',
        
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT IGNORE INTO s1_online \(name, uid, time, sit\) VALUES \(\'[^\']+\', \d{0,100}, \'\d{0,100}\', \d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+Insert into s1_login_log values \(\d{0,100},\d{0,100},\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_ndata \(id, uid, toWref, ally, topic, ntype, data, time, viewed\) values \(0,\'\d{0,100}\',\'\d{0,100}\',\'\d{0,100}\',\'[^\']+\',\d{0,100},\'[^\']+\',\d{0,100},\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_movement values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_send values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_general values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_enforcement \(vref,`from`\) values \(\d{0,100},\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_bdata values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+Insert into s1_build_log values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_mdata values \(\d{0,100},\d{0,100},\d{0,100},\'[^\']+\',\'[^\']+\',\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_mdata \(`target`, `owner`, `topic`, `message`, `viewed`, `archived`, `send`, `time`,`deltarget`,`delowner`,`alliance`,`player`,`coor`,`report`\) VALUES (\(\d{0,100}, \d{0,100}, \'[^\']+\', "[^"]+", \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100},\d{0,100}\)(,)?)*\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_gold_fin_log \(wid,log\) VALUES \(\'\d{0,100}\', \'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+Insert into s1_gold_fin_log values \(\d{0,100},\d{0,100},\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_research values \(\d{0,100},\d{0,100},\'[^\']+\'\,\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+Insert into s1_tech_log values \(\d{0,100},\d{0,100},\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_demolition VALUES \(\d{0,100},\d{0,100},\d{0,100},\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_training values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+Insert into s1_market_log values \(\d{0,100},\d{0,100},\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_vdata \(wref, owner, name, capital, pop, cp, celebration, wood, clay, iron, maxstore, crop, maxcrop, lastupdate, created\) values \(\d{0,100}, \d{0,100}, \'[^\']+\', \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}, \d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_fdata \(vref,f1t,f2t,f3t,f4t,f5t,f6t,f7t,f8t,f9t,f10t,f11t,f12t,f13t,f14t,f15t,f16t,f17t,f18t,f26,f26t\) values\([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into (s1_units|s1_tdata|s1_abdata) \(vref\) values \(\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_a2b \(ckey,time_check,to_vid,u1,u2,u3,u4,u5,u6,u7,u8,u9,u10,u11,type\) VALUES \(\'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_attacks values \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_forum_cat values \(\d{0,100},\'[^\']+\',\'[^\']+\',\'[^\']+\',\'[^\']+\',\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_forum_topic values \(\d{0,100},\'[^\']*\',\'[^\']*\',\'[^\']+\',\'[^\']+\',\'[^\']+\',\'[^\']+\',\'[^\']+\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\d{0,100},\d{0,100},\d{0,100},\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_forum_survey \(topic,title,option1,option2,option3,option4,option5,option6,option7,option8,ends\) values \(\'[^\']+\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_chat \(id_user,name,alli,date,msg\) values \(\d{0,100},\'[^\']+\',\'[^\']+\',\'[^\']+\',\'[^\']+\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_ali_log values \(\d{0,100},\'[^\']+\',\'[^\']+\',\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_diplomacy \(alli1,alli2,type,accepted\) VALUES \([^)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_ali_invite values \([^\)]+\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+Insert into s1_admin_log values \(\d{0,100},(\'[^\']+\'|\d{0,100}),\'[^\']+\',\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO s1_users \((id,)?username,password,access,email,timestamp,tribe,(location,)?act,protect(,lastupdate,regtime,is_bcrypt)?\) VALUES \((\d{0,100}, )?\'[^\']+\', \'[^\']+\', \d{0,100}, \'[^\']+\', \d{0,100}, \d{0,100},( \'[^\']*\',)? \'[^\']*\', \d{0,100}(, \d{0,100}, \d{0,100},\d{0,100})?\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_alidata values \(\d{0,100},\'[^\']*\',\'[^\']*\',\d{0,100},\d{0,100},\d{0,100},\d{0,100},\'[^\']*\',\'[^\']*\',\d{0,100},\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT into s1_ali_permission values\(\d{0,100},\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\',\'[^\']*\'\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+INSERT INTO `s1_artefacts` \(`vref`, `owner`, `type`, `size`, `conquered`, `name`, `desc`, `effect`, `img`, `active`\) VALUES \(\'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']+\', \'[^\']*\', \'[^\']+\', \'[^\']+\'\)\n/',
        
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_(active|online) WHERE (timestamp < \d{0,100}|(user)?name =( )?\'[^\']+\')\n/i',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_bdata where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE from s1_route where timeleft < \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_enforcement WHERE u1=0 AND u2=0 AND u3=0 AND u4=0 AND u5=0 AND u6=0 AND u7=0 AND u8=0 AND u9=0 AND u10=0 AND u11=0 AND u12=0 AND u13=0 AND u14=0 AND u15=0 AND u16=0 AND u17=0 AND u18=0 AND u19=0 AND u20=0 AND u21=0 AND u22=0 AND u23=0 AND u24=0 AND u25=0 AND u26=0 AND u27=0 AND u28=0 AND u29=0 AND u30=0 AND u31=0 AND u32=0 AND u33=0 AND u34=0 AND u35=0 AND u36=0 AND u37=0 AND u38=0 AND u39=0 AND u40=0 AND u41=0 AND u42=0 AND u43=0 AND u44=0 AND u45=0 AND u46=0 AND u47=0 AND u48=0 AND u49=0 AND u50=0 AND hero=0 AND \(vref=\d{0,100} OR `from`=\d{0,100}\)\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_training where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_research where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_bdata WHERE field=\d{0,100} AND wid=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_demolition WHERE vref=\d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE from s1_forum_topic where (id|cat) = \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE from s1_forum_survey where topic = \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE from s1_forum_cat where id = \'\d{0,100}\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE from s1_ali_permission where uid = \'[^\']+\'\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+DELETE FROM s1_ali_invite where id = \d{0,100}\n/',
        '/(\d{0,100} \d{1,2}:\d{1,2}:\d{1,2})?[ \t]+\d{1,100}[ \t]+Query[ \t]+TRUNCATE s1_bdata\n/',
    ];
    
    echo preg_replace($regexes, '', $src);
?>
